require 'omniauth/strategies/oauth2'

module OmniAuth
  module Strategies
    class RealGravity < OmniAuth::Strategies::OAuth2

      option :name, :realgravity

      option :client_options, {
        site: 'http://client.realgravity.com',
        authorize_url: '/oauth/authorize',
      }

      uid { raw_info['id'] }

      info do
        {
          name:       raw_info['name'],
          email:      raw_info['email'],
          network_id: raw_info['network_id'],
          company_id: raw_info['company_id'],
          roles:      raw_info['roles'],
        }
      end

      def raw_info
        @raw_info ||= access_token.get('/api/v2/me.json').parsed
      end

    end
  end
end

OmniAuth.config.add_camelization 'realgravity', 'RealGravity'
